using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections;
using System.Text;

public partial class _Default : System.Web.UI.Page, ICallbackEventHandler
{
    private Hashtable cities = new Hashtable();

    protected void Page_Load(object sender, EventArgs e)
    {
        cities.Add("MA", new String[] { "Boston", "Salem", "Waltham" });
        cities.Add("CO", new String[] { "Denver", "Boulder", "Colorado Springs" });
        cities.Add("CA", new String[] { "San Jose", "San Francisco", "Los Angeles" });
        cities.Add("TX", new String[] { "Austin", "Houston", "Dallas" });

        if (!IsPostBack)
        {
            StatesList.DataSource = new String[] { "MA", "CO", "CA", "TX" };
            StatesList.DataBind();

            String callbackRef =
        ClientScript.GetCallbackEventReference(
        this, "selectedState", "ReceiveDataFromServer", "context");

            String callbackScript =
                "function CallServer(selectedState, context) {" + callbackRef + "; }";
            
            ClientScript.RegisterClientScriptBlock(
                GetType(), "CallServer", callbackScript, true);

            string ReceiveDataFromServerScript =
                "function ReceiveDataFromServer(rvalue, context) {document.getElementById(\"CitiesList\").innerHTML = rvalue;}";
            
            ClientScript.RegisterClientScriptBlock(
                GetType(), "ReceiveDataFromServer", ReceiveDataFromServerScript, true);

            StatesList.Attributes.Add("OnClick",
                "CallServer(document.getElementById(\"StatesList\").value, '');");
        }
    }

    protected void States_SelectedIndexChanged(object sender, EventArgs e)
    {
        CitiesList.DataSource = cities[StatesList.SelectedValue] as String[];
        CitiesList.DataBind();
    }

    #region ICallbackEventHandler Members

    string selectedState;

    public string GetCallbackResult()
    {
        StringBuilder citylist = new StringBuilder();
        foreach (String city in cities[selectedState] as String[])
        {
            citylist.Append("<option>" + city + "</option>");
        }

        return citylist.ToString();
    }

    public void RaiseCallbackEvent(string eventArgument)
    {
        selectedState = eventArgument;
    }

    #endregion
}
